
Ruby - Bug #2053

`for` No Longer Splats When RHS Returns More Values Than LHS Expects

09/06/2009 02:17 AM - runpaint (Run Paint Run Run)

Status: Closed   

Priority: Normal   

Assignee: matz (Yukihiro Matsumoto)   

Target version: 1.9.2   

ruby -v: ruby 1.9.2dev (2009-09-05 trunk 24762)

[i686-linux]

Backport:  

Description

=begin

$ cat /tmp/for.rb

class OFor

def each

[[1,2,3], [4,5,6]].each do |a|

yield(a[0],a[1],a[2])

end

end

end

o = OFor.new

qs = []

for q in o

qs << q

end

p qs

p q

$ ruby8 -v /tmp/for.rb

ruby 1.8.8dev (2009-09-04) [i686-linux]

/tmp/for.rb:11: warning: multiple values for a block parameter (3 for 1)

from /tmp/for.rb:4

/tmp/for.rb:11: warning: multiple values for a block parameter (3 for 1)

from /tmp/for.rb:4

[[1, 2, 3], [4, 5, 6]]

[4, 5, 6]

$ ruby -v /tmp/for.rb

ruby 1.9.2dev (2009-09-05 trunk 24762) [i686-linux]

[1, 4]

4

=end

History

#1 - 09/07/2009 11:06 AM - yugui (Yuki Sonoda)

- Assignee set to matz (Yukihiro Matsumoto)

- Priority changed from Normal to 3

- Target version set to 1.9.2

=begin

=end

#2 - 09/10/2009 11:14 PM - nobu (Nobuyoshi Nakada)

=begin

Hi,

At Sun, 6 Sep 2009 02:17:17 +0900,

Run Paint Run Run wrote in [ruby-core:25414]:
$ cat /tmp/for.rb

class OFor

def each

[[1,2,3], [4,5,6]].each do |a|

yield(a[0],a[1],a[2])

end

end

end

o = OFor.new

qs = []

for q in o

qs << q

end

p qs

p q

 It should be an intentional change, I think.

--

Nobu Nakada

=end

#3 - 09/11/2009 05:04 PM - runpaint (Run Paint Run Run)

=begin

Thanks, nobu. I've updated the spec. Don't leave this ticket open on my account. :-)

=end

#4 - 09/19/2009 01:59 AM - nobu (Nobuyoshi Nakada)

- Status changed from Open to Closed

=begin

=end
